"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SplitIOProvider = void 0;

var _react = _interopRequireWildcard(require("react"));

var _SplitIOContext = require("./SplitIOContext");

var _useInitSplitClient = require("./hooks/use-init-split-client");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

/**
 * @param {string} splitKey                 internal user id, or the organisation id that the user belongs to
 * @param {string} authorizationKey         your split api key
 * @param {string[]} splits                 split names
 * @param {Object} attributes               user attributes to determine split treatment value
 */
var SplitIOProvider = function SplitIOProvider(_ref) {
  var splitKey = _ref.splitKey,
      authorizationKey = _ref.authorizationKey,
      trafficType = _ref.trafficType,
      _ref$labelsEnabled = _ref.labelsEnabled,
      labelsEnabled = _ref$labelsEnabled === void 0 ? true : _ref$labelsEnabled,
      splits = _ref.splits,
      attributes = _ref.attributes,
      children = _ref.children,
      options = _objectWithoutProperties(_ref, ["splitKey", "authorizationKey", "trafficType", "labelsEnabled", "splits", "attributes", "children"]);

  var client = (0, _useInitSplitClient.useInitSplitClient)(_objectSpread({
    key: splitKey,
    authorizationKey: authorizationKey,
    trafficType: trafficType,
    labelsEnabled: labelsEnabled
  }, options));

  var _useState = (0, _react.useState)({}),
      _useState2 = _slicedToArray(_useState, 2),
      treatments = _useState2[0],
      setTreatments = _useState2[1];

  var stringifedAttributes = JSON.stringify(attributes);
  (0, _react.useEffect)(function () {
    if (!client) {
      return;
    }

    var values = client.getTreatments(splits, attributes);
    setTreatments(values);
  }, [stringifedAttributes, splitKey, client]);
  return _react.default.createElement(_SplitIOContext.SplitIOContext.Provider, {
    value: {
      treatments: treatments,
      client: client
    }
  }, children);
};

exports.SplitIOProvider = SplitIOProvider;