"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useInitSplitClient = void 0;

var _react = require("react");

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var useInitSplitClient = function useInitSplitClient(_ref) {
  var key = _ref.key,
      authorizationKey = _ref.authorizationKey,
      trafficType = _ref.trafficType,
      _ref$labelsEnabled = _ref.labelsEnabled,
      labelsEnabled = _ref$labelsEnabled === void 0 ? true : _ref$labelsEnabled,
      startup = _ref.startup,
      scheduler = _ref.scheduler,
      storage = _ref.storage;

  var _useState = (0, _react.useState)(),
      _useState2 = _slicedToArray(_useState, 2),
      splitClient = _useState2[0],
      setSplitClient = _useState2[1];

  var hasSplitLoaded = typeof splitio !== 'undefined';
  (0, _react.useEffect)(function () {
    var initSplitClient =
    /*#__PURE__*/
    function () {
      var _ref2 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee() {
        var client;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!(!key || !hasSplitLoaded)) {
                  _context.next = 2;
                  break;
                }

                return _context.abrupt("return");

              case 2:
                // eslint-disable-next-line no-undef
                client = splitio({
                  core: {
                    authorizationKey: authorizationKey,
                    key: key,
                    trafficType: trafficType,
                    labelsEnabled: labelsEnabled
                  },
                  startup: startup,
                  scheduler: scheduler,
                  storage: storage
                }).client();
                client.on(client.Event.SDK_READY, function () {
                  setSplitClient(client);
                });

              case 4:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function initSplitClient() {
        return _ref2.apply(this, arguments);
      };
    }();

    initSplitClient();
  }, [key, hasSplitLoaded]);
  return splitClient;
};

exports.useInitSplitClient = useInitSplitClient;